<!DOCTYPE html>
<html>
<head>
	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

	<!-- responsive meta tag -->
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	<title>Bootstrap Flex</title>

</head>

<body>

	<h1 class="text-center my-5">Bootstrap Flex</h1>

	<!-- 
		Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS However, using bootstrap it is much easier and faster to implement flex because all we have to do is add class d-flex to the PARENT of our flex items.

		Flex items, Flex Children, when adding d-flex to their parent the items are in a row. we can adjust their height and width.

		*flex items will allow us to adjust the height and width regardless if it is inline or block

		Flex Row Reverse
		starts our items from the opposite side(right) and reverses the order 




	-->


	<div class="bg-dark d-flex mb-4" style="height: 80vh;"> 
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		
	</div>

	<div class="bg-dark d-flex flex-row mb-4" style="height: 80vh;">
		<span class="bg-primary p-2" style="height: 30%; width: 30%;">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4" style="height: 80vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4" style="height: 80vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-column bg-dark mb-4 p-4" >
		<span class="bg-primary p-2" style="height: 300px; width: 300px;" >Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<!-- reversed . from the bottom up -->
	<h3 class="text-center my-5">Flex Column Reverse</h3>
	<div class="d-flex flex-column-reverse bg-dark mb-4 p-4" >
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- allows to horizontally align your flex-row items -->
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!--  justify-content-start the default value of justify-content for flex items. It allows us to align our flex items to the start of their main axis. For flex-row it starts from the left, for flex-row-revenge it starts from the right. -->
	<div class="bg-dark d-flex flex-row justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


<div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content End</h3>
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>	



	<h3 class="text-center my-5">Justify Content center</h3>
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>s
	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>	



	<h3 class="text-center my-5">Justify Content Between</h3>
	<!-- justify-content-between add/disttributes remaining spaces between our items -->
	<div class="bg-dark d-flex flex-row justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>	


	<h3 class="text-center my-5">Justify Content Around</h3>
	<div class="bg-dark d-flex flex-row justify-content-around mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>	


<!-- Align Items -->
<h2 class="text-center">Align Items</h2>
<!-- align-items - aligns your items vertically for flex-row and flext reverse -->

<h2 class="text-center">Align Items Start</h2>
	<div class="bg-dark d-flex flex-row align-items-start mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


<div class="bg-dark d-flex flex-row-reverse align-items-start mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<h2 class="text-center">Align Items End</h2>

	<div class="bg-dark d-flex flex-row align-items-end mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>


	<div class="bg-dark d-flex flex-row-reverse align-items-end mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>


	<h2 class="text-center">Align Items Center</h2>

	<div class="bg-dark d-flex flex-row align-items-center mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>


	<div class="bg-dark d-flex flex-row-reverse align-items-center mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>


	<h2 class="text-center">Aligning Items Horizontally and Vertically</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<!-- Mini Activity -->

	<h3 class="my-5 text-center">Mini-Activity with Flex Flow</h3>

	<div class="d-flex flex-row justify-content-center align-items-center bg bg-dark" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-between bg-dark" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>

	</div>


	<h2 class="text-center my-5">Flex Colum with Align Items and Justify Conten</h2>
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
	</div>

	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
	</div>




<!-- Mini-Activity  with Flex Column -->
<h3 class="text-center my-5">Mini-Activity  with Flex Column</h3>
<div class="d-flex flex-column bg-dark mb-4 justify-content-end" style="height: 50vh;">
	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
</div>

<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height: 50vh;">
	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
</div>



<h3 class="text-center my-5">Flex Column: with Justify Content and between</h3>
<div class="d-flex flex-column bg-dark mb-4 justify-content-between" style="height: 50vh;">
	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
</div>


<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height: 50vh;">
	<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	<div class="bg-success p-2" style="width: 20%;">Flex Item 3</div>
</div>

<h3 class="text-center my-5">Flex Wrap</h3>
<div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4">
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex Item 2</div>
	<div class="bg-success p-2">Flex Item 3</div>
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex Item 2</div>
	<div class="bg-success p-2">Flex Item 3</div>
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex Item 2</div>
	<div class="bg-success p-2">Flex Item 3</div>

</div>












	<!-- 

		Flex-Row 
		Flex-Row-Reverse

		Flex-Column
		Flex-Column-reverse
		Justify-Content-Start
		Justify-Content-End 
		Justify-Content-Center
		Justify-Content-Between
		Justify-Content-Around

		align-items-start
		align-items-end
		align-items-center
	-->




	<!-- js dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
	<!-- js dependencies END-->

</body>
</html>